unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms, Dialogs, Menus,
  ExtCtrls, StdCtrls, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Options1: TMenuItem;
    Help1: TMenuItem;
    Exit1: TMenuItem;
    About1: TMenuItem;
    Savescreenshot1: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Setup1: TMenuItem;
    b_s1: TSpeedButton;
    b_s2: TSpeedButton;
    b_s3: TSpeedButton;
    Timer_s: TTimer;
    N1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Timer2: TTimer;
    b_s4: TSpeedButton;
    b_te: TSpeedButton;
    b_ti: TSpeedButton;
    Label4: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    level: TTrackBar;
    Label5: TLabel;
    b_e1: TSpeedButton;
    b_e2: TSpeedButton;
    Label6: TLabel;
    Bevel1: TBevel;
    Panel4: TPanel;
    Label3: TLabel;
    b_on: TSpeedButton;
    b_off: TSpeedButton;
    Label7: TLabel;
    Bevel2: TBevel;
    Label8: TLabel;
    Bevel3: TBevel;
    Label9: TLabel;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    timer_r: TTimer;
    Choicedatafile1: TMenuItem;
    SaveDialog2: TSaveDialog;
    procedure Exit1Click(Sender: TObject);
    procedure Setup1Click(Sender: TObject);
    procedure Timer_sTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Savescreenshot1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure b_sClick(Sender: TObject);
    procedure b_rClick(Sender: TObject);
    procedure b_dClick(Sender: TObject);
    procedure Choicedatafile1Click(Sender: TObject);
    procedure timer_rTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var Form1: TForm1;

implementation

uses Unit2,Unit3,D2XXUnit;

{$R *.dfm}

procedure TForm1.About1Click(Sender: TObject);
begin // menu-about
aboutbox.ShowModal;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin // menu-exit
close;
end;

procedure TForm1.Setup1Click(Sender: TObject);
begin
if form2.ShowModal=mrok then
   begin // menu-options
   //save
   end;
end;

var// oscdata:array[0..320] of integer;
    hdcmem,hdcform,hdcbg:hdc;
    hbg,hmem:hbitmap;
    bbg,bmem:tbitmap;
    _pen:hpen;
    _brush:hbrush;
    rawdata:array[0..1000] of byte;
    pdata:array[0..1000] of tpoint;
    deviceok:boolean;
    divider:integer;
    busy:boolean;
    dotcnt:integer;
    recfile:textfile;
    recording:boolean;
    reccounter:integer;

procedure drawscope;
begin  // 
bitblt(hdcmem,0,0,bbg.Width,bbg.Height,hdcbg,0,0,SRCCOPY);
polyline(hdcmem,pdata,{320}dotcnt);
if recording then
   begin
   SetTextColor(hdcmem,clred);
   SetbkColor(hdcmem,clblack);
   TextOut(hdcmem,260,2,'Recording',9);
   end;
bitblt(hdcform,0,0,bbg.Width,bbg.Height,hdcmem,0,0,SRCCOPY);
end;

procedure setBaudRate(n:integer);
begin
FT_Current_Baud:=n;
Set_USB_Device_BaudRate;
end;

procedure startscope;
begin
if recording then closefile(recfile);
recording:=false;
dotcnt:=320;
form1.timer_s.Enabled:=true;  //   
form1.timer_r.Enabled:=false;
end;

procedure startrecorder;
begin
if recording then closefile(recfile);
dotcnt:=0;
form1.timer_r.Enabled:=true;  //   
form1.timer_s.Enabled:=false;
assignfile(recfile,form1.SaveDialog2.FileName);
rewrite(recfile);
writeln(recfile,'DATE: '+datetimetostr(now));
writeln(recfile,'TIME STEP: 1 = '+inttostr(form1.timer2.interval div 1000)+' s');
writeln(recfile,'VOLTAGE STEP: 1 = '+floattostr(0.01*divider)+' V');
writeln(recfile);
writeln(recfile,'N    VALUE');
writeln(recfile);
recording:=true;
reccounter:=0;
end;

procedure setparamdevice;
begin
Set_USB_Device_LatencyTimer(20);
//Set_USB_Device_TimeOuts(300,300);

Set_USB_Device_BitMode($00,$00);
set_USB_Device_BitMode($14,$01);
//Set_USB_Parameters(28000,34*800);   //  (in,out)
setBaudRate(27200);
divider:=1;
busy:=false;
startscope;
end;

procedure initdevice;
var err:boolean;
begin
FT_Enable_Error_Report := False;
err:=false;
GetFTDeviceCount;
if FT_Device_Count>0 then
   begin
   If Open_USB_Device_By_Device_Description(form2.edit1.Text) = FT_OK then
      begin
      setparamdevice;
      deviceok:=true;
      form1.b_on.enabled:=true;
//      form1.b_off.enabled:=true;
      form1.b_on.Down:=true;
      end else err:=true;
   end else err:=true;
if err then
   begin
   deviceok:=false;
   form1.b_on.enabled:=false;
//   form1.b_off.enabled:=false;
   form1.b_off.Down:=true;
   end;
end;

procedure donedevice;
begin
deviceok:=false;
FT_Enable_Error_Report := False;
close_USB_device;
form1.b_on.enabled:=false;
//form1.b_off.enabled:=false;
form1.b_off.Down:=true;
end;

procedure initoutbuf;
var b,i:integer;
begin
b:=0;
repeat
FT_Out_Buffer[b]:=255;
FT_Out_Buffer[b+1]:=255;
inc (b,2);
for i:=0 to 15 do
    begin
    FT_Out_Buffer[b+i*2]:=255-16; //cs
    FT_Out_Buffer[b+i*2+1]:=255-16-4; //cs //clk 1
    end;
inc (b,32);
until b>32000;
end;

procedure drawvolt(mval:real);
var   { mval:integer;}
    mvalr:real;
begin
mvalr:=((127-mval)/255)*2.50*divider;
form1.panel4.Caption:=format('%.3f',[mvalr]);
form1.panel4.Font.Color:=form2.Shape2.Brush.Color;
form1.panel4.Color:=form2.Shape1.Brush.Color;
end;

procedure getdatadevice;
var b,d,v,bit:integer;
    bb:byte;
begin
Purge_USB_Device_Out;
Purge_USB_Device_in;

Write_USB_Device_Buffer(34*960);
Read_USB_Device_Buffer(32768);


for b:=0 to 640 do rawdata[b]:=0;

b:=0; //base in FT_In_Buffer
d:=0; //base in rawdata
v:=0; //temp value
bit:=0;//bit counter
repeat
if FT_In_Buffer[b] and 32>0 then // CS=1
   begin
   if bit>15{0}  then
      begin
      bb:=v shr 4; // 4  
//      if bb>127 then
      rawdata[d]:=bb-unit2.zeroadj;
      inc(d);
      end;
   bit:=0;
   v:=0;
   end
else
if FT_In_Buffer[b] and 4>0 then // CLK=1
   begin
   if FT_In_Buffer[b] and 8>0 then //data
      inc(v,$8000 shr bit);
   inc(bit);
   end;
inc(b);
until b>={16384}32768;
end;

procedure TForm1.Timer_sTimer(Sender: TObject);
var start,i:integer;
    lev:integer;
    mval:integer;
begin
if not deviceok then exit;
if busy then exit;
if b_off.Down then exit;
busy:=true;

//
//
//

getdatadevice;

mval:=0;
for i:=1 to 16 do inc(mval,rawdata[i]);
drawvolt(mval/16);

start:=1;
lev:=(level.Position*255) div 10;

if form1.b_te.Down then
   begin
   if form1.b_e1.Down then
      begin
      for i:=0 to 640 do
          begin
          if (rawdata[i]<lev)and(rawdata[i+1]>lev) then begin start:=i;break;end;
          end;
      end
   else
      begin
      for i:=0 to 640 do
          begin
          if (rawdata[i]>lev)and(rawdata[i+1]<lev) then begin start:=i;break;end;
          end;
      end;
   end;


for i:=1 to 320 do
    begin
    pdata[i-1].y:=rawdata[start+i-1]+20;
    pdata[i-1].x:=i+11;
    end;

drawscope;
busy:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
hdcform:=getdc(form1.Panel1.Handle);
hdcmem:=CreateCompatibleDC(hdcform);
hdcbg:=CreateCompatibleDC(hdcform);
_pen:=CreatePen(PS_SOLID,1,clyellow{form2.Shape1.Brush.Color});
_brush:=createsolidbrush(clblack);

bbg:=tbitmap.Create;
bbg.LoadFromFile('grid.bmp');
hbg:=bbg.Handle;
hmem:=createcompatiblebitmap(hdcform,bbg.Width,bbg.Height);

selectobject(hdcbg,hbg);
selectobject(hdcmem,hmem);
selectobject(hdcmem,_pen);

initoutbuf;
deviceok:=false;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
deleteobject(_pen);
deleteobject(_brush);
deleteobject(hbg);
deleteobject(hmem);
deletedc(hdcMem);
deletedc(hdcbg);
end;

procedure TForm1.Savescreenshot1Click(Sender: TObject);
var img:tbitmap;
begin
img:=tbitmap.Create;
img.Handle:=hmem;
if savedialog1.Execute then
   img.SaveToFile(savedialog1.FileName);
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
//if not deviceok then initdevice;
GetFTDeviceCount;
if FT_Device_Count>0 then
   begin
   if not deviceok then initdevice;
   end
else
   begin
   donedevice;
   end;

{
GetFTDeviceCount;
if FT_Device_Count>0 then
   begin
   if not b_on.Enabled then initdevice;
   end
else
   begin
   if b_on.Enabled then donedevice;
   end;
}
end;

procedure TForm1.b_sClick(Sender: TObject);
begin  // time/div  (scope)
setbaudrate(tspeedbutton(sender).Tag);
startscope;
end;

procedure TForm1.b_rClick(Sender: TObject);
begin  // time/div  (recorder)
timer_r.Interval:=(tspeedbutton(sender).Tag);
startrecorder;
end;

procedure TForm1.b_dClick(Sender: TObject);
begin  // divider
divider:=(tspeedbutton(sender).Tag);
end;

procedure TForm1.Choicedatafile1Click(Sender: TObject);
begin
savedialog2.Execute;
end;

procedure TForm1.timer_rTimer(Sender: TObject);
var start,i:integer;
    lev:integer;
    mval:integer;
    mvalr:real;
begin
if not deviceok then exit;
if busy then exit;
if b_off.Down then exit;
busy:=true;

//
//
//
getdatadevice;

mval:=0;
for i:=2 to 5 do inc(mval,rawdata[i]);
drawvolt(mval/4);
mval:=mval div 4;
inc(reccounter);writeln(recfile,reccounter,' ',127-mval);

start:=1;
{
for i:=1 to 320 do
    begin
    pdata[i-1].y:=rawdata[start+i-1]+20;
    pdata[i-1].x:=i+11;
    end;
}

pdata[dotcnt].y:=mval+20;
pdata[dotcnt].x:=dotcnt+11;
inc(dotcnt);
if dotcnt>320 then dotcnt:=0;

drawscope;
busy:=false;
end;

end.


